/* (C) 2001-2002 Andrew J. Kroll */
/* see file README for license details */
/*
 I do realize this is a bunch of large settings , but screw it :-) 
 change it if you want.
 I don't see it as that bad... even on a 48k TPA box
 If your seriously pressed halve the buffers, don't dink with the
 MAXMTUMRU as I do NOT support frags yet!
 No mallocs are used for the purpose of raw speed. 
 One less call on a z80 makes for huge cpu time savings!
*/

#ifndef NETINET_H_SEEN
#define NETINET_H_SEEN

#ifndef CONFIG_H_SEEN
#include "config.h"
#endif


/* 
These are used instead of struct because 
it remidies any sizeof() issues.
It may aslo make the code more readable.
To the compiler, it's like precalculated structures...
*/

#define SOKAT(x) (sockets + (SOKDAT * x)) /* calculate socket offset */
/* socket "struct" */
#define IPDEST(x,y) (y + (SOKDAT * x))	/*  4  bytes		*/
#define SRCPRT(x,y) (IPDEST(x,y) +  4)	/*  2  bytes		*/
#define DESPRT(x,y) (IPDEST(x,y) +  6)	/*  2  bytes		*/
#define SEQNUM(x,y) (IPDEST(x,y) +  8)	/*  4  bytes		*/
#define ACKNUM(x,y) (IPDEST(x,y) + 12)	/*  4  bytes 		*/
#define BUFUSE(x,y) (IPDEST(x,y) + 16)	/*  1  byte		*/
#define BUFSTA(x,y) (IPDEST(x,y) + 17)	/*  1  byte		*/
#define WINDOW(x,y) (IPDEST(x,y) + 18)	/*  2  bytes		*/
#define SOCKFD(x,y) (IPDEST(x,y) + 20)	/*  1  byte		*/
#define SOCKST(x,y) (IPDEST(x,y) + 21)	/*  1  byte		*/
#define STTYPE(x,y) (IPDEST(x,y) + 22)	/*  1  byte		*/
#define STPROT(x,y) (IPDEST(x,y) + 23)	/*  1  byte		*/
#define SOKMSS(x,y) (IPDEST(x,y) + 24)	/*  2  bytes		*/
#define SLANOD(x,y) (IPDEST(x,y) + 26)	/*  1  byte		*/
#define SPARET(x,y) (IPDEST(x,y) + 27)	/*  1  byte		*/
#define SPARPO(x,y) (IPDEST(x,y) + 28)	/*  1  byte		*/
/*                                         ---------            */
/*                                         29 bytes total	*/


/* ip "struct" */
#define DESTIP(x) (x+12)

/* tcp "struct" */
#define PRTSRC(x,y) (x+y+0)
#define PRTDES(x,y) (x+y+2)
#define NUMSEQ(x,y) (x+y+4)
#define NUMACK(x,y) (x+y+8)

#include "net.h"

/* unsynchronized states */
#define STATE_CLOSED 0
/* these three misc socket states are placeholders for socket functions */
#define STATE_BIND 1
#define STATE_BOUND 2
#define STATE_LISTEN 3
#define STATE_NOTINIT 6
#define STATE_SYN_SENT 7
#define STATE_SYN_RECEIVED 8
/* special "state" for UDP */
#define STATE_UDP 32
/* synchronized states */
#define STATE_ESTABLISHED 64
#define STATE_CLOSEWAIT 128
#define STATE_CLOSING 129
#define STATE_FINWAIT1 130
#define STATE_FINWAIT2 131
#define STATE_LAST_ACK 132
#define STATE_TIME_WAIT 255

#define URG 32
#define ACK 16
#define PSH 8
#define RST 4
#define SYN 2
#define FIN 1

#endif /* NETINET_H_SEEN */
